@echo off

@if not exist comenb16.log goto nolog
attrib -r comenb16.log
:nolog
comenb16 off > comenb16.log

@if not exist xup.log goto noxlog
attrib -r xup.log
del xup.log
:noxlog

comenb16 >> comenb16.log
if errorlevel == 44 goto com4
if errorlevel == 43 goto com3
if errorlevel == 42 goto com2
if errorlevel == 41 goto com1
if errorlevel == 12 goto noenab
if errorlevel == 11 goto cardserv
goto noenab

:noenab
@echo      Modem could not be enabled.  Please ensure that the card is fully
@echo      inserted in the slot and rerun the utility.  Consult the README
@echo      file for further information.
goto end

REM
REM --uputil returns 0 if successful, 1 if it needs iflash, 
REM --2 if it needs a clean boot and iflash, and 3 if there was 
REM --an error or user abort...
REM

:cardserv
uputil /s > xup.log
if errorlevel == 3 goto dontflash
if errorlevel == 2 goto reboot
if errorlevel == 1 goto iflash
if errorlevel == 0 goto xupresult
goto end

:iflash
comenb16 off >> comenb16.log
comenb16 >> comenb16.log
if errorlevel == 41 goto doiflash
if errorlevel == 12 goto reboot
if errorlevel == 11 goto reboot

:doiflash
comenb16 off >> comenb16.log
iflash temp.pak
if errorlevel == 1 goto xfail
attrib -r temp.pak
del temp.pak
crlf
goto end

:xfail
@echo      Card could not be flashed. Consult the README file
@echo      for further information.
goto end

:reboot
@echo      Card Services is running.  Please reboot without Card
@echo      Services and run iflash to upgrade the card.  For
@echo      further information consult the README file.
goto end

:com4
uputil  /c4 > xup.log
if errorlevel == 2 goto dontflash
if errorlevel == 1 goto iflash
if errorlevel == 0 goto xupresult
goto cardoff

:com3
uputil  /c3 > xup.log
if errorlevel == 2 goto dontflash
if errorlevel == 1 goto iflash
if errorlevel == 0 goto xupresult
goto cardoff

:com2
uputil  /c2 > xup.log
if errorlevel == 2 goto dontflash
if errorlevel == 1 goto iflash
if errorlevel == 0 goto xupresult
goto cardoff

:com1
uputil  /c1 > xup.log
if errorlevel == 2 goto dontflash
if errorlevel == 1 goto iflash
if errorlevel == 0 goto xupresult
goto cardoff

:xupresult
:dontflash
echo Please reboot your machine to re-enable your Adapter
comenb16 off > NUL
type xup.log
crlf
goto end

:cardoff
comenb16 off

:end
